Package com.collabnet.ce.soap60.webservices.tracker

# Interface ITrackerAppSoap

All Known Implementing Classes:
  `TrackerAppSoap`, `TrackerAppSoapMockStub`, `TrackerAppSoapStub`

public interface ITrackerAppSoap

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addDateField(String sessionId, String trackerId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String helpText)`
  Adds a custom Date field to a tracker.
  `void`
  `addMultiSelectField(String sessionId, String trackerId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String[] defaultValues, String helpText)`
  Adds a custom multi select field to a tracker.
  `void`
  `addSeparator(String sessionId, String trackerId, String separatorType, String separatorLabel)`
  Adds a separator to a tracker.
  `void`
  `addSingleSelectChildField(String sessionId, String trackerId, String fieldName, String[] fieldValues, String parentFieldId, SoapNamedValues parentChildFieldValueMap, String helpText)`
  Adds a custom single select field to a tracker.
  `void`
  `addSingleSelectField(String sessionId, String trackerId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String defaultValue, String helpText)`
  Adds a custom single select field to a tracker.
  `void`
  `addTextField(String sessionId, String trackerId, String fieldName, int displayColumns, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String defaultValue, String helpText, String pattern)`
  Adds a custom text field to a tracker.
  `void`
  `addUserSelectField(String sessionId, String trackerId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] defaultValues, String userFilter, String helpText)`
  Adds a custom User selection field to a tracker.
  `Tracker2SoapDO`
  `cloneTracker(String sessionId, String srcTrackerId, String destTrackerTitle, String destTrackerDescription)`
  Clone Tracker within the same project
  `Tracker2SoapDO`
  `cloneTrackerAcrossProject(String sessionId, String srcTrackerId, String destProjectId, String destTrackerTitle, String destTrackerDescription)`
  Clone Tracker across the project
  `void`
  `copyWorkflowTransitions(String sessionId, String srcTrackerId, String dstTrackerId)`
  Copies workflow transitions between two trackers.
  `ArtifactSoapDO`
  `createArtifact(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, String assignedUsername, String releaseId, String planningFolderId, SoapFieldValues flexFields, String attachmentFileName, String attachmentMimeType, String attachmentFileId)`
  Deprecated.
  in favor of createArtifact4
  `ArtifactSoapDO`
  `createArtifact2(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, String assignedUsername, String releaseId, String planningFolderId, SoapFieldValues flexFields, AttachmentSoapDO[] attachments)`
  Deprecated.
  in favor of createArtifact4
  `Artifact2SoapDO`
  `createArtifact3(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, boolean autoSummingPoints, String assignedUsername, String releaseId, String planningFolderId, String teamId, SoapFieldValues flexFields, AttachmentSoapDO[] attachments)`
  Deprecated.
  in favor of createArtifact4
  `Artifact3SoapDO`
  `createArtifact4(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, boolean autoSummingPoints, String assignedUsername, String releaseId, String planningFolderId, String teamId, SoapFieldValues flexFields, AttachmentSoapDO[] attachments, String[] tagNames)`
  Creates a new artifact with multiple attachments, flag to enable the autosumming_points and tags.
  `void`
  `createArtifactDependency(String sessionId, String originId, String targetId, String desc)`
  Creates an artifact dependency between two artifacts.
  `TrackerSoapDO`
  `createTracker(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon)`
  Deprecated.
  use createTracker3 instead, which includes tracker unit and autosum foreign children support
  `Tracker2SoapDO`
  `createTracker2(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon, String trackerUnitId)`
  Deprecated.
  use createTracker3 instead, which includes foreign children support
  `Tracker3SoapDO`
  `createTracker3(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon, String trackerUnitId, boolean autosumForeignChildren)`
  Creates a new tracker with autosum foreign children support
  `void`
  `deleteArtifact(String sessionId, String artifactId)`
  Deletes an artifact.
  `void`
  `deleteField(String sessionId, String objectId, String fieldId)`
  Deletes a custom/flex-field .
  `void`
  `deleteSeparator(String sessionId, String trackerId, String layoutId)`
  Deletes a separator of a tracker layout.
  `ArtifactSoapList`
  `findArtifacts(String sessionId, String queryString, String projectId, boolean searchAttachments)`
  Deprecated.
  in favor of findArtifacts2
  `Artifact2SoapList`
  `findArtifacts2(String sessionId, String queryString, String projectId, boolean searchAttachments)`
  Finds a list of artifacts matching a search string.
  `WorkflowTransitionSoapList`
  `getAllowedWorkflowTransitionList(String sessionId, String trackerId)`
  Deprecated.
  in favor of getAllowedWorkflowTransitionList2
  `WorkflowTransition2SoapList`
  `getAllowedWorkflowTransitionList2(String sessionId, String trackerId)`
  Deprecated.
  in favor of getAllowedWorkflowTransitionList3
  `WorkflowTransition3SoapList`
  `getAllowedWorkflowTransitionList3(String sessionId, String trackerId)`
  Gets workflow transitions for the tracker.
  `ArtifactSoapDO`
  `getArtifactData(String sessionId, String artifactId)`
  Deprecated.
  in favor of getArtifactData3
  `Artifact2SoapDO`
  `getArtifactData2(String sessionId, String artifactId)`
  Deprecated.
  in favor of getArtifactData3
  `Artifact3SoapDO`
  `getArtifactData3(String sessionId, String artifactId)`
  Returns data associated with the specified artifact.
  `ArtifactDetailSoapList`
  `getArtifactDetailList(String sessionId, String trackerId, String[] selectedColumns, SoapFilter[] filters, SoapSortKey[] sortKeys, int startIndex, int maxRows, boolean exceptionIfExpiredCache, boolean forceNewQuery)`
  Deprecated.
  in favor of getArtifactDetailList2
  `ArtifactDetail2SoapList`
  `getArtifactDetailList2(String sessionId, String trackerId, String[] selectedColumns, SoapFilter[] filters, SoapSortKey[] sortKeys, int startIndex, int maxRows, boolean exceptionIfExpiredCache, boolean forceNewQuery)`
  Returns a filtered and ordered list of artifacts from the specified tracker.
  `ArtifactSoapList`
  `getArtifactList(String sessionId, String containerId, SoapFilter[] filters)`
  Deprecated.
  in fovor of getArtifactList2
  `Artifact2SoapList`
  `getArtifactList2(String sessionId, String containerId, SoapFilter[] filters)`
  Returns a filtered list of artifacts within the specified container (project or tracker).
  `ArtifactDependencySoapList`
  `getChildDependencyList(String sessionId, String artifactId)`
  Gets the dependency list for an artifact where the artifact is the origin artifact.
  `ArtifactDetailSoapList`
  `getCrossTrackerArtifactList(String sessionId, String containerId, SoapFilter[] filters, String[] selectedColumns)`
  Deprecated.
  in favor of getCrossTrackerArtifactList2
  `ArtifactDetail2SoapList`
  `getCrossTrackerArtifactList2(String sessionId, String containerId, SoapFilter[] filters, String[] selectedColumns)`
  Returns a filtered list of artifacts within the specified container (project or tracker).
  `TrackerFieldSoapDO[]`
  `getFields(String sessionId, String trackerId)`
  Deprecated.
  use getFields2 instead
  `TrackerField2SoapDO[]`
  `getFields2(String sessionId, String trackerId)`
  Returns the custom/flex-fields associated with a specific tracker.
  `OrderedTrackerFieldSoapList`
  `getOrderedTrackerFields(String sessionId, String trackerId)`
  Returns all fields and separators in the given tracker with layout information.
  `ArtifactDependencySoapList`
  `getParentDependencyList(String sessionId, String artifactId)`
  Gets the dependency list for an artifact where the artifact is the target artifact.
  `Tracker2SoapDO`
  `getTracker2Data(String sessionId, String trackerId)`
  Deprecated.
  use getTracker3Data instead, which includes autosum foreign children support
  `Tracker2SoapList`
  `getTracker2List(String sessionId, String projectId)`
  Deprecated.
  use getTracker3List instead, which includes autosum foreign children support
  `Tracker3SoapDO`
  `getTracker3Data(String sessionId, String trackerId)`
  Returns a data object for a given tracker
  `Tracker3SoapList`
  `getTracker3List(String sessionId, String projectId)`
  Returns a list of trackers for a project in the order that they are displayed in the UI.
  `TrackerSoapDO`
  `getTrackerData(String sessionId, String trackerId)`
  Deprecated.
  use getTracker3Data instead, which includes tracker unit and autosum foreign children support
  `TrackerSoapList`
  `getTrackerList(String sessionId, String projectId)`
  Deprecated.
  use getTracker3List instead, which includes tracker unit and autosum foreign children support
  `TrackerUnitSoapList`
  `getUnitsByProject(String sessionId, String projectId)`
  Gets the units for a given project.
  `ArtifactSoapDO`
  `moveArtifact(String sessionId, String artifactId, String targetFolderId, String newAssignee)`
  Deprecated.
  in favor of moveArtifact2
  `Artifact2SoapDO`
  `moveArtifact2(String sessionId, String artifactId, String targetFolderId, String newAssignee)`
  Moves an artifact to a specified target folder.
  `void`
  `removeArtifactDependency(String sessionId, String originId, String targetId)`
  Removes an artifact dependency between two artifacts.
  `void`
  `reorderTrackerFields(String sessionId, String trackerId, String[] layoutIds)`
  Sets a new order of the fields and the separators within a tracker.
  `void`
  `reorderTrackers(String sessionId, String[] trackerIds)`
  Sets a new order of the trackers within a project.
  `void`
  `setArtifactData(String sessionId, ArtifactSoapDO artifactData, String comment, String attachmentFileName, String attachmentMimeType, String attachmentFileId)`
  Deprecated.
  in favor of setArtifactData4
  `void`
  `setArtifactData2(String sessionId, ArtifactSoapDO artifactData, String comment, AttachmentSoapDO[] attachments)`
  Deprecated.
  in favor of setArtifactData4
  `void`
  `setArtifactData3(String sessionId, Artifact2SoapDO artifactData, String comment, AttachmentSoapDO[] attachments)`
  Deprecated.
  in favor of setArtifactData4
  `void`
  `setArtifactData4(String sessionId, Artifact3SoapDO artifactData, String comment, AttachmentSoapDO[] attachments)`
  Sets data associated along with multiple attachments with the specified artifact.
  `void`
  `setArtifactRank(String sessionId, String planningFolderId, String artfToRankId, String artfBeforeId, String artfAfterId)`
  Sets the rank of an artifact relative to one or more other artifacts
  `void`
  `setField(String sessionId, String objectId, TrackerFieldSoapDO fieldData)`
  Deprecated.
  use setField2 instead
  `void`
  `setField2(String sessionId, String objectId, TrackerField2SoapDO fieldData)`
  Sets a custom/flex-field that is associated with a specific folder
  `void`
  `setTracker2Data(String sessionId, Tracker2SoapDO trackerData)`
  Deprecated.
  use setTracker3Data instead, which includes autosum foreign children support
  `void`
  `setTracker3Data(String sessionId, Tracker3SoapDO trackerData)`
  Sets data on a specific tracker with autosum foreign children support
  `void`
  `setTrackerData(String sessionId, TrackerSoapDO trackerData)`
  Deprecated.
  use setTracker3Data instead, which includes tracker unit and autosum foreign children support

- ## Method Details

  - ### getTrackerList

    @Deprecated TrackerSoapList getTrackerList(String sessionId, String projectId) throws RemoteException
    Deprecated.
    use getTracker3List instead, which includes tracker unit and autosum foreign children support
    Returns a list of trackers for a project in the order that they are displayed in the UI.
    Parameters:
      `sessionId` - User session id.
      `projectId` - Project id.
    Returns:
      List of trackers within the project.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.1

  - ### getTracker2List

    @Deprecated Tracker2SoapList getTracker2List(String sessionId, String projectId) throws RemoteException
    Deprecated.
    use getTracker3List instead, which includes autosum foreign children support
    Returns a list of trackers for a project in the order that they are displayed in the UI.
    Parameters:
      `sessionId` - User session id.
      `projectId` - Project id.
    Returns:
      List of trackers within the project.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      6.2

  - ### getTracker3List

    Tracker3SoapList getTracker3List(String sessionId, String projectId) throws RemoteException
    Returns a list of trackers for a project in the order that they are displayed in the UI.
    Parameters:
      `sessionId` - User session id.
      `projectId` - Project id.
    Returns:
      List of trackers within the project.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      8.0

  - ### getTrackerData

    @Deprecated TrackerSoapDO getTrackerData(String sessionId, String trackerId) throws RemoteException
    Deprecated.
    use getTracker3Data instead, which includes tracker unit and autosum foreign children support
    Returns a data object for a given tracker
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
    Returns:
      Detailed data on the tracker.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      "4.2"

  - ### getTracker2Data

    @Deprecated Tracker2SoapDO getTracker2Data(String sessionId, String trackerId) throws RemoteException
    Deprecated.
    use getTracker3Data instead, which includes autosum foreign children support
    Returns a data object for a given tracker
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
    Returns:
      Detailed data on the tracker.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      "6.2"

  - ### getTracker3Data

    Tracker3SoapDO getTracker3Data(String sessionId, String trackerId) throws RemoteException
    Returns a data object for a given tracker
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
    Returns:
      Detailed data on the tracker.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      8.0

  - ### setTrackerData

    @Deprecated void setTrackerData(String sessionId, TrackerSoapDO trackerData) throws RemoteException
    Deprecated.
    use setTracker3Data instead, which includes tracker unit and autosum foreign children support
    Sets data on a specific tracker
    Parameters:
      `sessionId` - User session id.
      `trackerData` - Detailed data on the tracker to set.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid or field or icon could not be found.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `IllegalArgumentFault` - when invalid data is specified.
      `VersionMismatchFault` - when the object version mismatches the application server.
      `RemoteException`
    Since:
      4.2

  - ### setTracker2Data

    @Deprecated void setTracker2Data(String sessionId, Tracker2SoapDO trackerData) throws RemoteException
    Deprecated.
    use setTracker3Data instead, which includes autosum foreign children support
    Sets data on a specific tracker
    Parameters:
      `sessionId` - User session id.
      `trackerData` - Detailed data on the tracker to set.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid or field or icon could not be found.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `IllegalArgumentFault` - when invalid data is specified.
      `VersionMismatchFault` - when the object version mismatches the application server.
      `RemoteException`
    Since:
      6.2

  - ### setTracker3Data

    void setTracker3Data(String sessionId, Tracker3SoapDO trackerData) throws RemoteException
    Sets data on a specific tracker with autosum foreign children support
    Parameters:
      `sessionId` - User session id.
      `trackerData` - Detailed data on the tracker to set.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid or field or icon could not be found.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `IllegalArgumentFault` - when invalid data is specified.
      `VersionMismatchFault` - when the object version mismatches the application server.
      `RemoteException`
    Since:
      8.0

  - ### createTracker

    @Deprecated TrackerSoapDO createTracker(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon) throws RemoteException
    Deprecated.
    use createTracker3 instead, which includes tracker unit and autosum foreign children support
    Creates a new tracker with an icon
    Parameters:
      `sessionId` - User session id.
      `projectId` - The id of the project under which to create the new tracker
      `trackerName` - The name of the new tracker
      `trackerTitle` - The title of the new tracker
      `trackerDescription` - The description of the new tracker
      `icon` - The tracker icon (null or something between "icon_01.png" and "icon_99.png")
    Returns:
      the tracker soap object
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `NoSuchObjectFault` - when the specified object id is invalid or icon could not be found.
      `ObjectAlreadyExistsFault` - if an existing tracker already exists
      `RemoteException`
    Since:
      4.3-HOTFIX1

  - ### createTracker2

    @Deprecated Tracker2SoapDO createTracker2(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon, String trackerUnitId) throws RemoteException
    Deprecated.
    use createTracker3 instead, which includes foreign children support
    Creates a new tracker with an icon
    Parameters:
      `sessionId` - User session id.
      `projectId` - The id of the project under which to create the new tracker
      `trackerName` - The name of the new tracker
      `trackerTitle` - The title of the new tracker
      `trackerDescription` - The description of the new tracker
      `icon` - The tracker icon (null or something between "icon_01.png" and "icon_99.png")
      `trackerUnitId` - The tracker unit
    Returns:
      the tracker soap object
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `NoSuchObjectFault` - when the specified object id is invalid or icon could not be found.
      `ObjectAlreadyExistsFault` - if an existing tracker already exists
      `RemoteException`
    Since:
      6.2

  - ### createTracker3

    Tracker3SoapDO createTracker3(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon, String trackerUnitId, boolean autosumForeignChildren) throws RemoteException
    Creates a new tracker with autosum foreign children support
    Parameters:
      `sessionId` - User session id.
      `projectId` - The id of the project under which to create the new tracker
      `trackerName` - The name of the new tracker
      `trackerTitle` - The title of the new tracker
      `trackerDescription` - The description of the new tracker
      `icon` - The tracker icon (null or something between "icon_01.png" and "icon_99.png")
      `trackerUnitId` - The tracker unit
      `autosumForeignChildren` - The flag indicating whether the autosum calculation of effort and points includes children from foreign projects
    Returns:
      the tracker soap object
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `NoSuchObjectFault` - when the specified object id is invalid or icon could not be found.
      `ObjectAlreadyExistsFault` - if an existing tracker already exists
      `IllegalArgumentFault` - if the arguments are incorrectly specified
      `RemoteException`
    Since:
      8.0

  - ### setField

    @Deprecated void setField(String sessionId, String objectId, TrackerFieldSoapDO fieldData) throws RemoteException
    Deprecated.
    use setField2 instead
    Sets a custom/flex-field that is associated with a specific folder
    Parameters:
      `sessionId` - User session id.
      `objectId` - Object (e.g. tracker) for which to set the field information.
      `fieldData` - the custom/flex-field to associate with a specific folder
    Throws:
      `NoSuchObjectFault` - when the specified object id or fieldData is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
      `IllegalArgumentFault` - if the arguments are incorrectly specified.
      `InvalidOperationFault` - if the operation is not allowed.
      `SystemFault` - when an unexpected system error occurs.
      `DependencyViolationFault` - if changing a status violates artifact dependency
      `RemoteException`
    Since:
      4.3-HOTFIX1
    See Also:
      - `FaultSummary`

  - ### setField2

    void setField2(String sessionId, String objectId, TrackerField2SoapDO fieldData) throws RemoteException
    Sets a custom/flex-field that is associated with a specific folder
    Parameters:
      `sessionId` - User session id.
      `objectId` - Object (e.g. tracker) for which to set the field information.
      `fieldData` - the custom/flex-field to associate with a specific folder
    Throws:
      `NoSuchObjectFault` - when the specified object id or fieldData is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
      `IllegalArgumentFault` - if the arguments are incorrectly specified.
      `InvalidOperationFault` - if the operation is not allowed.
      `SystemFault` - when an unexpected system error occurs.
      `DependencyViolationFault` - if changing a status violates artifact dependency
      `RemoteException`
    Since:
      16.7
    See Also:
      - `FaultSummary`

  - ### addTextField

    void addTextField(String sessionId, String trackerId, String fieldName, int displayColumns, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String defaultValue, String helpText, String pattern) throws RemoteException
    Adds a custom text field to a tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker to add the field to.
      `fieldName` - the name of the field
      `displayColumns` - the width of the display area
      `displayLines` - the height of the display area
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `defaultValue` - default value
      `helpText` - The help text for the field
      `pattern` - The field validation pattern
    Throws:
      `NoSuchObjectFault` - when the specified object id or fieldData is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
      `IllegalArgumentFault` - if the arguments are incorrectly specified
      `InvalidOperationFault` - if the operation is not allowed
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.3-HOTFIX1

  - ### addSingleSelectChildField

    void addSingleSelectChildField(String sessionId, String trackerId, String fieldName, String[] fieldValues, String parentFieldId, SoapNamedValues parentChildFieldValueMap, String helpText) throws RemoteException
    Adds a custom single select field to a tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker to add the field to.
      `fieldName` - the name of the field
      `fieldValues` - Array of valid field values
      `parentFieldId` - The id of the parent field
      `parentChildFieldValueMap` - soapNamedValues which keeps mapping between parent field values and child values
      `helpText` - the help text for the field
    Throws:
      `NoSuchObjectFault` - when the specified object id or fieldData is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
      `IllegalArgumentFault` - if the arguments are incorrectly specified
      `InvalidOperationFault` - if the operation is not allowed
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      5.4.1

  - ### addSingleSelectField

    void addSingleSelectField(String sessionId, String trackerId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String defaultValue, String helpText) throws RemoteException
    Adds a custom single select field to a tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker to add the field to.
      `fieldName` - the name of the field
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `fieldValues` - Array of valid field values
      `defaultValue` - default value
      `helpText` - the help text for the field
    Throws:
      `NoSuchObjectFault` - when the specified object id or fieldData is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
      `IllegalArgumentFault` - if the arguments are incorrectly specified
      `InvalidOperationFault` - if the operation is not allowed
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.3-HOTFIX1

  - ### addMultiSelectField

    void addMultiSelectField(String sessionId, String trackerId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String[] defaultValues, String helpText) throws RemoteException
    Adds a custom multi select field to a tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker to add the field to.
      `fieldName` - the name of the field
      `displayLines` - the height of the display area
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `fieldValues` - possible values
      `defaultValues` - default values
      `helpText` - the help text for the field
    Throws:
      `NoSuchObjectFault` - when the specified object id or fieldData is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
      `IllegalArgumentFault` - if the arguments are incorrectly specified
      `InvalidOperationFault` - if the operation is not allowed
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.3-HOTFIX1

  - ### addUserSelectField

    void addUserSelectField(String sessionId, String trackerId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] defaultValues, String userFilter, String helpText) throws RemoteException
    Adds a custom User selection field to a tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker to add the field to.
      `fieldName` - the name of the field
      `displayLines` - the height of the display area
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `defaultValues` - default values for this field. Must be valid usernames
      `userFilter` - is the filter
      `helpText` - The help text of the field
    Throws:
      `NoSuchObjectFault` - when the specified object id or fieldData is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
      `IllegalArgumentFault` - if the arguments are incorrectly specified
      `InvalidOperationFault` - if the operation is not allowed
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.3-SP1
    See Also:
      - `TrackerFieldSoapDO.FIELD_USER_FILTER_PROJECT_MEMBER`
      - `TrackerFieldSoapDO.FIELD_USER_FILTER_ALL`

  - ### addDateField

    void addDateField(String sessionId, String trackerId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String helpText) throws RemoteException
    Adds a custom Date field to a tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker to add the field to.
      `fieldName` - the name of the field
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `helpText` - the help text of the field
    Throws:
      `NoSuchObjectFault` - when the specified object id or fieldData is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
      `IllegalArgumentFault` - if the arguments are incorrectly specified
      `InvalidOperationFault` - if the operation is not allowed
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.3-SP1

  - ### deleteField

    void deleteField(String sessionId, String objectId, String fieldId) throws RemoteException
    Deletes a custom/flex-field .
    Parameters:
      `sessionId` - User session id.
      `objectId` - Object (e.g. tracker).
      `fieldId` - the id of the field to delete
    Throws:
      `NoSuchObjectFault` - when the specified object id or fieldData is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `InvalidOperationFault` - if the operation is not allowed.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.3-HOTFIX1

  - ### getFields

    @Deprecated TrackerFieldSoapDO[] getFields(String sessionId, String trackerId) throws RemoteException
    Deprecated.
    use getFields2 instead
    Returns the custom/flex-fields associated with a specific tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker for which to return field information.
    Returns:
      Array of all field values.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.3-HOTFIX1

  - ### getFields2

    TrackerField2SoapDO[] getFields2(String sessionId, String trackerId) throws RemoteException
    Returns the custom/flex-fields associated with a specific tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker for which to return field information.
    Returns:
      Array of all field values.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      16.7

  - ### addSeparator

    void addSeparator(String sessionId, String trackerId, String separatorType, String separatorLabel) throws RemoteException
    Adds a separator to a tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker to add the separator to.
      `separatorType` - the type of the separator
      `separatorLabel` - the label of the separator
    Throws:
      `NoSuchObjectFault` - when the specified object id is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `IllegalArgumentFault` - if the arguments are incorrectly specified
      `SystemFault` - when an unexpected system error occurs.
      `ObjectAlreadyExistsFault` - if a separator with the same id exists
      `RemoteException`
    Since:
      5.4.1

  - ### deleteSeparator

    void deleteSeparator(String sessionId, String trackerId, String layoutId) throws RemoteException
    Deletes a separator of a tracker layout.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker to delete the separator from.
      `layoutId` - the layout id of the separator. To get the layout id, use getOrderedTrackerFields.
    Throws:
      `NoSuchObjectFault` - when the specified object id is invalid
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `IllegalArgumentFault` - if the arguments are incorrectly specified
      `InvalidOperationFault` - if the operation is not allowed
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      5.4.1

  - ### getOrderedTrackerFields

    OrderedTrackerFieldSoapList getOrderedTrackerFields(String sessionId, String trackerId) throws RemoteException
    Returns all fields and separators in the given tracker with layout information.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - The tracker for which to return field information.
    Returns:
      Array of all fields and separators.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      5.4.1

  - ### reorderTrackerFields

    void reorderTrackerFields(String sessionId, String trackerId, String[] layoutIds) throws RemoteException
    Sets a new order of the fields and the separators within a tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Id of tracker which all the fields and the separators belong to.
      `layoutIds` - An array of layout ids which can be obtained by getOrderedTrackerFields().
    Throws:
      `InvalidSessionFault` - When the specified session id is invalid.
      `NoSuchObjectFault` - When any of the specified object id is invalid.
      `IllegalArgumentFault` - If invalid argument value is passed.
      `PermissionDeniedFault` - When the user has insufficient privileges.
      `SystemFault` - When an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.4.1

  - ### getArtifactList

    @Deprecated ArtifactSoapList getArtifactList(String sessionId, String containerId, SoapFilter[] filters) throws RemoteException
    Deprecated.
    in fovor of getArtifactList2
    Returns a filtered list of artifacts within the specified container (project or tracker).
    Parameters:
      `sessionId` - User session id.
      `containerId` - ID of a project or a tracker.
      `filters` - Array of filters to apply (null to return unfiltered list).
    Returns:
      List of filtered artifacts.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `InvalidFilterFault` - when the specified filters are invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.1

  - ### getArtifactList2

    Artifact2SoapList getArtifactList2(String sessionId, String containerId, SoapFilter[] filters) throws RemoteException
    Returns a filtered list of artifacts within the specified container (project or tracker).
    Parameters:
      `sessionId` - User session id.
      `containerId` - ID of a project or a tracker.
      `filters` - Array of filters to apply (null to return unfiltered list).
    Returns:
      List of filtered artifacts.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `InvalidFilterFault` - when the specified filters are invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      8.0

  - ### getCrossTrackerArtifactList

    @Deprecated ArtifactDetailSoapList getCrossTrackerArtifactList(String sessionId, String containerId, SoapFilter[] filters, String[] selectedColumns) throws RemoteException
    Deprecated.
    in favor of getCrossTrackerArtifactList2
    Returns a filtered list of artifacts within the specified container (project or tracker).
    Parameters:
      `sessionId` - User session id.
      `containerId` - ID of a project or a tracker. (should not be null)
      `filters` - Array of filters to apply (null to return unfiltered list).
      `selectedColumns` - String array of column names to be selected (null to return all columns).
    Returns:
      List of filtered artifacts.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `InvalidFilterFault` - when the specified filters are invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      5.3

  - ### getCrossTrackerArtifactList2

    ArtifactDetail2SoapList getCrossTrackerArtifactList2(String sessionId, String containerId, SoapFilter[] filters, String[] selectedColumns) throws RemoteException
    Returns a filtered list of artifacts within the specified container (project or tracker).
    Parameters:
      `sessionId` - User session id.
      `containerId` - ID of a project or a tracker. (should not be null)
      `filters` - Array of filters to apply (null to return unfiltered list).
      `selectedColumns` - String array of column names to be selected (null to return all columns).
    Returns:
      List of filtered artifacts.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `InvalidFilterFault` - when the specified filters are invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      8.0

  - ### getArtifactDetailList

    @Deprecated ArtifactDetailSoapList getArtifactDetailList(String sessionId, String trackerId, String[] selectedColumns, SoapFilter[] filters, SoapSortKey[] sortKeys, int startIndex, int maxRows, boolean exceptionIfExpiredCache, boolean forceNewQuery) throws RemoteException
    Deprecated.
    in favor of getArtifactDetailList2
    Returns a filtered and ordered list of artifacts from the specified tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
      `selectedColumns` - String array of column names to be selected (null to return all columns).
      `filters` - Array of filters to apply (null to return unfiltered list).
      `sortKeys` - Array of `SortKey` to apply
      `startIndex` - The index from which to return the results.
      `maxRows` - The max quantity of elements to be returned (-1 will return the full list).
      `exceptionIfExpiredCache` - Causes the method to throw an exception if it doesn't have the result in the cache
      `forceNewQuery` - force the re-execution of the query, ignoring any cached copy of the search result.
    Returns:
      List of filtered artifacts.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `InvalidFilterFault` - when the specified filters are invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.3-HOTFIX1

  - ### getArtifactDetailList2

    ArtifactDetail2SoapList getArtifactDetailList2(String sessionId, String trackerId, String[] selectedColumns, SoapFilter[] filters, SoapSortKey[] sortKeys, int startIndex, int maxRows, boolean exceptionIfExpiredCache, boolean forceNewQuery) throws RemoteException
    Returns a filtered and ordered list of artifacts from the specified tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.

      See ArtifactSoapDO for filters names constant values

      `sortKeys` - Array of `SortKey` to apply (null to return a default order list that is by ID).
      `startIndex` - The index from which to return the results.
      `maxRows` - The max quantity of elements to be returned (-1 will return the full list).
      `exceptionIfExpiredCache` - Causes the method to throw exception if it doesn't have the results in the cache
      `forceNewQuery` - force the re-execution of the query, ignoring any cached copy of the search result.
    Returns:
      List of filtered artifacts.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `InvalidFilterFault` - when the specified filters are invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      8.0

  - ### findArtifacts

    @Deprecated ArtifactSoapList findArtifacts(String sessionId, String queryString, String projectId, boolean searchAttachments) throws RemoteException
    Deprecated.
    in favor of findArtifacts2
    Finds a list of artifacts matching a search string.
    Parameters:
      `sessionId` - User session id.
      `queryString` - Query string.
      `projectId` - The project in which to find artifacts. (if null, search all projects)
      `searchAttachments` - Whether to search attachments.
    Returns:
      List of artifacts matching search criteria.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project id is invalid.
      `SearchQuerySyntaxFault` - when the specified search query string is syntactically invalid.
      `IllegalArgumentFault` - when the specified query string is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      4.1

  - ### findArtifacts2

    Artifact2SoapList findArtifacts2(String sessionId, String queryString, String projectId, boolean searchAttachments) throws RemoteException
    Finds a list of artifacts matching a search string.
    Parameters:
      `sessionId` - User session id.
      `queryString` - Query string.
      `projectId` - The project in which to find artifacts. (if null, search all projects)
      `searchAttachments` - Whether to search attachments.
    Returns:
      List of artifacts matching search criteria.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project id is invalid.
      `SearchQuerySyntaxFault` - when the specified search query string is syntactically invalid.
      `IllegalArgumentFault` - when the specified query string is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      8.0

  - ### getArtifactData

    @Deprecated ArtifactSoapDO getArtifactData(String sessionId, String artifactId) throws RemoteException
    Deprecated.
    in favor of getArtifactData3
    Returns data associated with the specified artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactId` - Artifact id.
    Returns:
      the data associated with the artifact at the given path
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.1

  - ### getArtifactData2

    @Deprecated Artifact2SoapDO getArtifactData2(String sessionId, String artifactId) throws RemoteException
    Deprecated.
    in favor of getArtifactData3
    Returns data associated with the specified artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactId` - Artifact id.
    Returns:
      the data associated with the artifact at the given path
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      8.0

  - ### getArtifactData3

    Artifact3SoapDO getArtifactData3(String sessionId, String artifactId) throws RemoteException
    Returns data associated with the specified artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactId` - Artifact id.
    Returns:
      the data associated with the artifact at the given path
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      17.4

  - ### setArtifactData

    @Deprecated void setArtifactData(String sessionId, ArtifactSoapDO artifactData, String comment, String attachmentFileName, String attachmentMimeType, String attachmentFileId) throws RemoteException
    Deprecated.
    in favor of setArtifactData4
    Sets data associated with the specified artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactData` - the data associated with the artifact at the given path
      `comment` - Comment associated with the change.
      `attachmentFileName` - Name of the attached file (or null)
      `attachmentMimeType` - Mime type of the attached file (or null)
      `attachmentFileId` - ID of the attached file (previously uploaded via *FileStorage service) or null
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - when the object data is stale.
      `IllegalArgumentFault` - when the artifact data is invalid.
      `InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid.
      `SystemFault` - when an unexpected system error occurs.
      `WorkflowViolationFault` - when workflow rule is violated
      `DependencyViolationFault` - when dependency rule is violated
      `PlanningFolderRuleViolationFault` - when planning folder rule is violated
      `RemoteException`
    Since:
      4.1

  - ### setArtifactData2

    @Deprecated void setArtifactData2(String sessionId, ArtifactSoapDO artifactData, String comment, AttachmentSoapDO[] attachments) throws RemoteException
    Deprecated.
    in favor of setArtifactData4
    Sets data associated along with multiple attachments with the specified artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactData` - the data associated with the artifact at the given path
      `comment` - Comment associated with the change.
      `attachments` - attached file List
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - when the object data is stale.
      `IllegalArgumentFault` - when the artifact data is invalid.
      `InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid.
      `SystemFault` - when an unexpected system error occurs.
      `WorkflowViolationFault` - when workflow rule is violated
      `DependencyViolationFault` - when dependency rule is violated
      `PlanningFolderRuleViolationFault` - when planning folder rule is violated
      `RemoteException`
    Since:
      6.2

  - ### setArtifactData3

    @Deprecated void setArtifactData3(String sessionId, Artifact2SoapDO artifactData, String comment, AttachmentSoapDO[] attachments) throws RemoteException
    Deprecated.
    in favor of setArtifactData4
    Sets data associated along with multiple attachments with the specified artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactData` - the data associated with the artifact at the given path
      `comment` - Comment associated with the change.
      `attachments` - attached file List
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - when the object data is stale.
      `IllegalArgumentFault` - when the artifact data is invalid.
      `InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid.
      `SystemFault` - when an unexpected system error occurs.
      `WorkflowViolationFault` - when workflow rule is violated
      `DependencyViolationFault` - when dependency rule is violated
      `PlanningFolderRuleViolationFault` - when planning folder rule is violated
      `RemoteException`
    Since:
      8.0

  - ### setArtifactData4

    void setArtifactData4(String sessionId, Artifact3SoapDO artifactData, String comment, AttachmentSoapDO[] attachments) throws RemoteException
    Sets data associated along with multiple attachments with the specified artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactData` - the data associated with the artifact at the given path
      `comment` - Comment associated with the change.
      `attachments` - attached file List
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `VersionMismatchFault` - when the object data is stale.
      `IllegalArgumentFault` - when the artifact data is invalid.
      `SystemFault` - when an unexpected system error occurs.
      `WorkflowViolationFault` - when workflow rule is violated
      `DependencyViolationFault` - when dependency rule is violated
      `PlanningFolderRuleViolationFault` - when planning folder rule is violated
      `InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
      `RemoteException`
    Since:
      17.4

  - ### createArtifact

    @Deprecated ArtifactSoapDO createArtifact(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, String assignedUsername, String releaseId, String planningFolderId, SoapFieldValues flexFields, String attachmentFileName, String attachmentMimeType, String attachmentFileId) throws RemoteException
    Deprecated.
    in favor of createArtifact4
    Creates a new artifact.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
      `title` - Artifact title.
      `description` - Artifact description.
      `group` - Artifact group.
      `category` - Artifact category.
      `status` - Artifact status.
      `customer` - Customer.
      `priority` - Artifact priority.
      `estimatedEffort` - Estimated effort to close artifact.
      `remainingEffort` - Remaining effort to close artifact.
      `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
      `points` - The story points for this artifact.
      `assignedUsername` - User this artifact should be assigned to.
      `releaseId` - Release this artifact is assigned with.
      `planningFolderId` - planning folder, this artifact belongs to
      `flexFields` - Flex field values.
      `attachmentFileName` - Name of the attached file (or null)
      `attachmentMimeType` - Mime type of the attached file (or null)
      `attachmentFileId` - ID of the attached file (previously uploaded via *FileStorage service) or null
    Returns:
      Newly created artifact object.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `IllegalArgumentFault` - when the artifact data is invalid.
      `InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      4.2

  - ### createArtifact2

    @Deprecated ArtifactSoapDO createArtifact2(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, String assignedUsername, String releaseId, String planningFolderId, SoapFieldValues flexFields, AttachmentSoapDO[] attachments) throws RemoteException
    Deprecated.
    in favor of createArtifact4
    Creates a new artifact with multiple attachments.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
      `title` - Artifact title.
      `description` - Artifact description.
      `group` - Artifact group.
      `category` - Artifact category.
      `status` - Artifact status.
      `customer` - Customer.
      `priority` - Artifact priority.
      `estimatedEffort` - Estimated effort to close artifact.
      `remainingEffort` - Remaining effort to close artifact.
      `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
      `points` - The story points for this artifact.
      `assignedUsername` - User this artifact should be assigned to.
      `releaseId` - Release this artifact is assigned with.
      `planningFolderId` - planning folder, this artifact belongs to
      `flexFields` - Flex field values.
      `attachments` - attached file List (or null)
    Returns:
      Newly created artifact object.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `IllegalArgumentFault` - when the artifact data is invalid.
      `InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      6.2

  - ### createArtifact3

    @Deprecated Artifact2SoapDO createArtifact3(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, boolean autoSummingPoints, String assignedUsername, String releaseId, String planningFolderId, String teamId, SoapFieldValues flexFields, AttachmentSoapDO[] attachments) throws RemoteException
    Deprecated.
    in favor of createArtifact4
    Creates a new artifact with multiple attachments and flag to enable the autosumming_points.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
      `title` - Artifact title.
      `description` - Artifact description.
      `group` - Artifact group.
      `category` - Artifact category.
      `status` - Artifact status.
      `customer` - Customer.
      `priority` - Artifact priority.
      `estimatedEffort` - Estimated effort to close artifact. This will be ignored if autosumming is set to true.
      `remainingEffort` - Remaining effort to close artifact. This will be ignored if autosumming is set to true.
      `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
      `points` - The story points for this artifact. This will be ignored if autoSummingPoints is set to true.
      `autoSummingPoints` - Determines whether autoSummingPoints should be enabled for the newly created artifact.
      `assignedUsername` - User this artifact should be assigned to.
      `releaseId` - Release this artifact is assigned with.
      `planningFolderId` - planning folder, this artifact belongs to
      `teamId` - team, this artifact belongs to
      `flexFields` - Flex field values.
      `attachments` - attached file List (or null)
    Returns:
      Newly created artifact object.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `IllegalArgumentFault` - when the artifact data is invalid.
      `InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      8.0

  - ### createArtifact4

    Artifact3SoapDO createArtifact4(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, boolean autoSummingPoints, String assignedUsername, String releaseId, String planningFolderId, String teamId, SoapFieldValues flexFields, AttachmentSoapDO[] attachments, String[] tagNames) throws RemoteException
    Creates a new artifact with multiple attachments, flag to enable the autosumming_points and tags.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
      `title` - Artifact title.
      `description` - Artifact description.
      `group` - Artifact group.
      `category` - Artifact category.
      `status` - Artifact status.
      `customer` - Customer.
      `priority` - Artifact priority.
      `estimatedEffort` - Estimated effort to close artifact. This will be ignored if autosumming is set to true.
      `remainingEffort` - Remaining effort to close artifact. This will be ignored if autosumming is set to true.
      `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
      `points` - The story points for this artifact. This will be ignored if autoSummingPoints is set to true.
      `autoSummingPoints` - Determines whether autoSummingPoints should be enabled for the newly created artifact.
      `assignedUsername` - User this artifact should be assigned to.
      `releaseId` - Release this artifact is assigned with.
      `planningFolderId` - planning folder, this artifact belongs to
      `teamId` - team, this artifact belongs to
      `flexFields` - Flex field values.
      `attachments` - attached file List (or null)
      `tagNames` - tag names
    Returns:
      Newly created artifact object.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `IllegalArgumentFault` - when the artifact data is invalid.
      `InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
      `RemoteException`
    Since:
      17.4

  - ### moveArtifact

    @Deprecated ArtifactSoapDO moveArtifact(String sessionId, String artifactId, String targetFolderId, String newAssignee) throws RemoteException
    Deprecated.
    in favor of moveArtifact2
    Moves an artifact to a specified target folder.
    Parameters:
      `sessionId` - User session id.
      `artifactId` - ID of artifact to move.
      `targetFolderId` - Target folder ID.
      `newAssignee` - The username to assign the newly moved artifact to.
    Returns:
      New artifact data object
    Throws:
      `InvalidSessionFault` - when the sessionId is invalid.
      `PermissionDeniedFault` - when permission is denied for the specified operation.
      `NoSuchObjectFault` - when the specified object is invalid.
      `SystemFault` - when an unexpected system error occurs.
      `IllegalArgumentFault` - when an invalid argument is passed in.
      `PlanningFolderRuleViolationFault` - when planning folder rule is violated
      `RemoteException`
    Since:
      4.2

  - ### moveArtifact2

    Artifact2SoapDO moveArtifact2(String sessionId, String artifactId, String targetFolderId, String newAssignee) throws RemoteException
    Moves an artifact to a specified target folder.
    Parameters:
      `sessionId` - User session id.
      `artifactId` - ID of artifact to move.
      `targetFolderId` - Target folder ID.
      `newAssignee` - The username to assign the newly moved artifact to.
    Returns:
      New artifact data object
    Throws:
      `InvalidSessionFault` - when the sessionId is invalid.
      `PermissionDeniedFault` - when permission is denied for the specified operation.
      `NoSuchObjectFault` - when the specified object is invalid.
      `SystemFault` - when an unexpected system error occurs.
      `IllegalArgumentFault` - when an invalid argument is passed in.
      `PlanningFolderRuleViolationFault` - when planning folder rule is violated
      `RemoteException`
    Since:
      8.0

  - ### deleteArtifact

    void deleteArtifact(String sessionId, String artifactId) throws RemoteException
    Deletes an artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactId` - Artifact id.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      4.1

  - ### getAllowedWorkflowTransitionList

    @Deprecated WorkflowTransitionSoapList getAllowedWorkflowTransitionList(String sessionId, String trackerId) throws RemoteException
    Deprecated.
    in favor of getAllowedWorkflowTransitionList2
    Gets workflow transitions for the tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
    Returns:
      Workflow definitions list.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when ...
      `RemoteException`
    Since:
      4.3

  - ### getAllowedWorkflowTransitionList2

    @Deprecated WorkflowTransition2SoapList getAllowedWorkflowTransitionList2(String sessionId, String trackerId) throws RemoteException
    Deprecated.
    in favor of getAllowedWorkflowTransitionList3
    Gets workflow transitions for the tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
    Returns:
      Workflow definitions list.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when ...
      `RemoteException`
    Since:
      17.8

  - ### copyWorkflowTransitions

    void copyWorkflowTransitions(String sessionId, String srcTrackerId, String dstTrackerId) throws RemoteException
    Copies workflow transitions between two trackers.
    Parameters:
      `sessionId` - User session id.
      `srcTrackerId` - Tracker id.
      `dstTrackerId` - Tracker id.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `WorkflowViolationFault` - when the copy of workflow transition cannot be completed
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      4.3-SP1-HOTFIX3

  - ### cloneTracker

    Tracker2SoapDO cloneTracker(String sessionId, String srcTrackerId, String destTrackerTitle, String destTrackerDescription) throws RemoteException
    Clone Tracker within the same project
    Parameters:
      `sessionId` - User session id.
      `srcTrackerId` - Tracker id.
      `destTrackerTitle` - destination Tracker tile
      `destTrackerDescription` - destination Tracker description
    Returns:
      returns cloned Tracker
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `ObjectAlreadyExistsFault` - if an existing tracker already exists.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      8.0

  - ### cloneTrackerAcrossProject

    Tracker2SoapDO cloneTrackerAcrossProject(String sessionId, String srcTrackerId, String destProjectId, String destTrackerTitle, String destTrackerDescription) throws RemoteException
    Clone Tracker across the project
    Parameters:
      `sessionId` - User session id.
      `srcTrackerId` - Tracker id.
      `destProjectId` - on which project you need to create a tracker
      `destTrackerTitle` - destination tracker title
      `destTrackerDescription` - destination tracker description
    Returns:
      returns cloned tracker
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `ObjectAlreadyExistsFault` - if an existing tracker already exists.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      8.0

  - ### createArtifactDependency

    void createArtifactDependency(String sessionId, String originId, String targetId, String desc) throws RemoteException
    Creates an artifact dependency between two artifacts.
    Parameters:
      `sessionId` - User session id.
      `originId` - Origin artifact id.
      `targetId` - Target artifact id.
      `desc` - Description for the dependency.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `WorkflowViolationFault` - when the copy of workflow transition cannot be completed
      `DependencyViolationFault` - when the creation of the dependency causes violation
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      4.4

  - ### removeArtifactDependency

    void removeArtifactDependency(String sessionId, String originId, String targetId) throws RemoteException
    Removes an artifact dependency between two artifacts.
    Parameters:
      `sessionId` - User session id.
      `originId` - Origin artifact id.
      `targetId` - Target artifact id.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `WorkflowViolationFault` - when the copy of workflow transition cannot be completed
      `DependencyViolationFault` - when the creation of the dependency causes violation
      `SystemFault` - when an unexpected system level error occurs.
      `NoSuchRelationshipFault` - when ...
      `RemoteException`
    Since:
      4.4

  - ### setArtifactRank

    void setArtifactRank(String sessionId, String planningFolderId, String artfToRankId, String artfBeforeId, String artfAfterId) throws RemoteException
    Sets the rank of an artifact relative to one or more other artifacts
    Parameters:
      `sessionId` - User session id.
      `planningFolderId` - the id of the planning folder in which we are doing the rank
      `artfToRankId` - the artifact to rank
      `artfBeforeId` - the artifact that should be before it
      `artfAfterId` - the artifact that should be after it
    Throws:
      `NoSuchObjectFault` - when one of the specified object id is invalid.
      `IllegalArgumentFault` - when the specified id is invalid.
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `InvalidRankFault` - when the requested rank operation is invalid
      `RemoteException`
    Since:
      5.4

  - ### getChildDependencyList

    ArtifactDependencySoapList getChildDependencyList(String sessionId, String artifactId) throws RemoteException
    Gets the dependency list for an artifact where the artifact is the origin artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactId` - Artifact id.
    Returns:
      dependency list
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `WorkflowViolationFault` - when the copy of workflow transition cannot be completed
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      4.4

  - ### getParentDependencyList

    ArtifactDependencySoapList getParentDependencyList(String sessionId, String artifactId) throws RemoteException
    Gets the dependency list for an artifact where the artifact is the target artifact.
    Parameters:
      `sessionId` - User session id.
      `artifactId` - Artifact id.
    Returns:
      dependency list
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `WorkflowViolationFault` - when the copy of workflow transition cannot be completed
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      4.4

  - ### reorderTrackers

    void reorderTrackers(String sessionId, String[] trackerIds) throws RemoteException
    Sets a new order of the trackers within a project.
    Parameters:
      `sessionId` - User session id.
      `trackerIds` - An array of the tracker ids in their new order.
    Throws:
      `InvalidSessionFault` - When the specified session id is invalid.
      `NoSuchObjectFault` - When any of the specified object id is invalid.
      `PermissionDeniedFault` - When the user has insufficient privileges.
      `SystemFault` - When an unexpected system level error occurs.
      `IllegalArgumentFault` - If invalid argument value is passed.
      `RemoteException`
    Since:
      5.4

  - ### getUnitsByProject

    TrackerUnitSoapList getUnitsByProject(String sessionId, String projectId) throws RemoteException
    Gets the units for a given project.
    Parameters:
      `sessionId` - User session id.
      `projectId` - The id of the project to retrieve the units
    Throws:
      `InvalidSessionFault` - When the specified session id is invalid.
      `NoSuchObjectFault` - When any of the specified object id is invalid.
      `PermissionDeniedFault` - When the user has insufficient privileges.
      `SystemFault` - When an unexpected system level error occurs.
      `IllegalArgumentFault` - If invalid argument value is passed.
      `RemoteException`
    Since:
      6.2

  - ### getAllowedWorkflowTransitionList3

    WorkflowTransition3SoapList getAllowedWorkflowTransitionList3(String sessionId, String trackerId) throws RemoteException
    Gets workflow transitions for the tracker.
    Parameters:
      `sessionId` - User session id.
      `trackerId` - Tracker id.
    Returns:
      Workflow definitions list.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `SystemFault` - when ...
      `RemoteException`
    Since:
      17.11